name: Deploy to Pages

on:
  push:
    branches: ['main']
  pull_request:
    branches: ['main']
  workflow_dispatch:

concurrency:
  group: 'pages'
  cancel-in-progress: false

jobs:
  build:
    runs-on: docker

    steps:
      - uses: actions/checkout@v4

      - name: Setup Node
        uses: actions/setup-node@v4
        with:
          node-version-file: '.nvmrc'
          cache: 'npm'

      - name: Install dependencies
        run: npm ci

      - name: Lint
        run: |
          npm run lint
          git diff
          if [[ `git status --porcelain` ]]; then
            exit 1
          fi

      - name: Typecheck
        run: npm run typecheck

      - name: Build & QA
        run: |
          npx playwright install chromium
          npm run qa

      - name: Copy build to host pages mount
        if: github.event_name == 'push' && github.ref == 'refs/heads/main'
        run: |
          apt update && apt install -y rsync
          mkdir -p /pages
          rsync -a --delete dist/ /pages/schmelczer-dev
